unit crepmain;
{***********************************************************************
CUSTOMISED REPORTS
ADDING FIELDS AT RUN TIME

This example code was written to illustrate the correct way to
add printable fields to a detail band at run-time.

NOTE : if you run the code more than once it keeps adding controls to
the report ! There are several ways to fix this - Left as an exercise.
No exception handling has been done.

Uses QR3.0.8 for Delphi 5

DLM 2/2001
************************************************************************}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, Buttons, QRExport;

type
  TfrmCustmain = class(TForm)
    SpeedButton1: TSpeedButton;
    Table1: TTable;
    QRCSVFilter1: TQRCSVFilter;
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmCustmain: TfrmCustmain;
  SelectedFields : TStringlist;

implementation
uses fldpick, Qrctrls, reportfrm, QuickRpt;

{$R *.DFM}

{******************************************************************
This is the simplest way to lay out the fields - using a single
column. The layout can be made as complex and clever as you
like, depending how much work you want to do.
*****************************************************************}
procedure TfrmCustmain.SpeedButton1Click(Sender: TObject);
var
     k : integer;
     TextCont : TQRDBText;
begin
     frmFieldpick.SrcList.clear;
     table1.Active := true;
     for k := 0 to table1.fielddefs.Count -1 do
          frmFieldpick.SrcList.Items.add( table1.fielddefs[k].name );

     frmFieldpick.showmodal;
     table1.close;
     if frmFieldpick.cancel or (frmFieldpick.DstList.Items.count=0) then
     begin
          exit;
     end;
     selectedfields := TStringlist.create;
     selectedfields.assign( frmFieldpick.DstList.Items );
     // put controls for each selected field on detail band of report
     for k := 0 to selectedfields.count-1 do
     begin
         textcont := TQRDBText(frmReport.bndDetail.AddPrintable(TQRDBText));
         // simple layout - put each field on its own line
         textcont.Left := 5;
         textcont.top := (k*20);
         textcont.width := 50;
         textcont.Height := 18;
         textcont.DataSet := frmReport.table1;
         textcont.DataField := selectedfields[k];
         // keep everything in synch and running smoothly ...
         application.processmessages;
     end;
     // adjust the detail band height to accomodate the fields.
     frmReport.bndDetail.Height := (selectedfields.count * 20 ) + 20;
     application.processmessages;
     // now just do a standard preview
     try
        frmReport.table1.active := true;
        frmReport.Customrep.Preview;
     finally
        frmReport.table1.close;
        selectedfields.free;
     end;
end;

end.
